#include <cstdio>
#include <vector>
#include <bitset>

using namespace std;

const int nmx = 10002;

int n,m,q;
vector <int> g[nmx];
bitset <nmx> viz;
int castiga[nmx], ps[10];
int nrp,start;

void citire()
{
    scanf("%d %d %d", &n, &m, &q);
    for(int i = 1; i <= m; ++i)
    {
        int nod1,nod2;
        scanf("%d  %d", &nod1, &nod2);
        g[nod1].push_back(nod2);
    }
}

int opus(int val)
{
    return val == 1 ? 2 : 1;
}

void parc(int nod, int rand)
{
    if(g[nod].size() == 0)
    {
        castiga[nod] = opus(rand);
        return;
    }

    if(viz[nod])
        rand = opus(rand);
    castiga[nod] = opus(rand);

    for(vector<int>::iterator it =  g[nod].begin(); it != g[nod].end(); ++it)
    {
        int next = opus(rand);
        parc(*it,next);
        if(castiga[*it] == rand)
            castiga[nod] = rand;
    }
}

int main()
{
    freopen("pawns.in", "r", stdin);
    freopen("pawns.out", "w", stdout);
    citire();

    while(q--)
    {
        int rezst = 0,rezdp = 0;
        for(int i = 1; i <= nrp; ++i)
            viz[ps[i]] = 0;
        scanf("%d", &nrp);
        for(int i = 1; i <= nrp; ++i)
            {
                scanf("%d", &ps[i]);
                viz[ps[i]] = 1;
            }
        scanf("%d", &start);
        for(int i = 1; i <= nrp; ++i)
        {
            viz[ps[i]] = 0;
            parc(ps[i],1);
            viz[ps[i]] = 1;
            if(castiga[ps[i]] == 1)
                ++ rezst;
            else
                ++ rezdp;
        }
        if(rezst % 2 == 1)
            printf("%d\n", start);
        else
            printf("%d\n", 1 - start);
    }
    return 0;
}
