#include <cstdio>
#include <cmath>
#include <algorithm>

using namespace std;
int m,n;
struct pct
{
    int x,y;
    double dist,pas;
};
struct pctfloat
{
    double x,y,dist,pas;
};


pct heri[200005],dracu[200005];
pctfloat vraji[400005];

FILE
*in=fopen("hogwarts.in","r"),
*out=fopen("hogwarts.out","w");

void sort_vraji()
{
    int a=1,b=1;
    for(a=1;a<m+n;++a)
        for(b=a+1;b<=m+n;++b)
            if(vraji[a].pas>vraji[b].pas)
            swap(vraji[a],vraji[b]);
}




int main()
{


    fscanf(in,"%d%d",&n,&m);
    double v;
    fscanf(in,"%lf",&v);
    int dx,dy;

    heri[0].x=0,
            heri[0].y=0,
                    heri[0].dist=0,
                            heri[0].pas=0;
    dracu[0].x=0,
             dracu[0].y=0,
                      dracu[0].dist=0,
                               dracu[0].pas=0;
    for(int i=1; i<=n; ++i)
    {
        fscanf(in,"%d%d",&heri[i].x,&heri[i].y);
        dx=heri[i].x-heri[i-1].x;
        dx=dx*dx;
        dy=heri[i].y-heri[i-1].y;
        dy=dy*dy;
        heri[i].pas=(double)(sqrt(dy+dx)/v);
        heri[i].dist=(double)heri[i-1].dist+heri[i].pas;
    }
    for(int i=1; i<=m; ++i)
    {
        fscanf(in,"%d%d",&dracu[i].x,&dracu[i].y);
        dx=dracu[i].x-dracu[i-1].x;
        dx=dx*dx;
        dy=dracu[i].y-dracu[i-1].y;
        dy=dy*dy;
        dracu[i].pas=(double)sqrt(dy+dx);
        dracu[i].dist=(double)dracu[i-1].dist+dracu[i].pas;
    }

    vraji[0].x=0,
             vraji[0].y=0,
                      vraji[0].dist=0,
                               vraji[0].pas=0;
    int k=0,vrajlen=0;
    for(int i=1; i<=n; ++i)
    {
        ///intai faci pentru fiecare punct a lu heri:
        if(heri[i].dist<=dracu[m].dist)
        {
            /// cand dracu inca fuge
            while(heri[i].dist>dracu[k].dist)++k;
            --k;
            float drum;
            drum=(double)(heri[i].dist-dracu[k].dist);
            float raport;
            raport=(double)(drum/dracu[k+1].pas);
            pct poz_dracu;
            poz_dracu.pas=(double)dracu[k].x*(1-raport)+(double)(raport)*dracu[k+1].x;
            poz_dracu.dist=(double)dracu[k].y*(1-raport)+(double)(raport)*dracu[k+1].y;


            vraji[++vrajlen].x=(double) 2*heri[i].x- poz_dracu.pas;
            vraji  [vrajlen].y=(double) 2*heri[i].y- poz_dracu.dist;
            vraji  [vrajlen].pas=(double) heri[i].dist;
        }
        else
        {
            /// cand dracu sta
            vraji[++vrajlen].x=(double) 2*heri[i].x- dracu[m].x;
            vraji  [vrajlen].y=(double) 2*heri[i].y- dracu[m].y;
            vraji  [vrajlen].pas=(double) heri[i].dist;
        }
    }

    k=0;
    for(int i=1; i<=n; ++i)
    {
        ///apoi faci pentru fiecare punct a lu draku:
        if(dracu[i].dist<=heri[n].dist)
        {
            /// cand heri inca fuge
            while(dracu[i].dist>heri[k].dist)++k;
            --k;
            float drum=(double)dracu[i].dist-heri[k].dist;
            float raport=(double)drum/heri[k+1].pas;
            pct poz_heri;
            poz_heri.pas=(double)heri[k].x*(1-raport)+(double)(raport)*heri[k+1].x;
            poz_heri.dist=(double)heri[k].y*(1-raport)+(double)(raport)*heri[k+1].y;


            vraji[++vrajlen].x=(double) 2*poz_heri.pas- dracu[i].x;
            vraji  [vrajlen].y=(double) 2*poz_heri.dist- dracu[i].y;
            vraji  [vrajlen].pas=(double) dracu[i].dist;
        }
        else
        {
            /// cand dracu sta
            vraji[++vrajlen].x=(double) 2*heri[n].x- dracu[i].x;
            vraji  [vrajlen].y=(double) 2*heri[n].y- dracu[i].y;
            vraji  [vrajlen].pas=(double) dracu[i].dist;
        }
    }

    sort_vraji();

    for(k=1;k<=m+n;++k)
    {
        dx=vraji[k].x-vraji[k-1].x;
        dy=vraji[k].y-vraji[k-1].y;
        dx=dx*dx;
        dy=dy*dy;

        vraji[k].pas=(double)(sqrt(dy+dx));
        vraji[k].dist=(double)vraji[k-1].dist+vraji[k].pas;
    }
 fprintf(out,"%lf",vraji[m+n].dist);
    return 0;
}
