#include <iostream>
#include <cstdio>
#include <vector>
#include <bitset>
#include <queue>

#define mp make_pair

using namespace std;

const int MMax = 50005;
const int NMax = 10005;
const int Max_Pioni= 100005;

vector < int > G[MMax];
int N, M, Q, poz , nod, x1;
queue < pair < int,int > > Qu;

int viz[NMax], marc[NMax], dg[NMax];

int BFS1(int &x)
{
    Qu.push(mp(nod,x));

    viz[nod]=1;
    marc[nod]=x;

    while(!Qu.empty())
    {
        int y=Qu.front().first;
        x1=Qu.front().second;
        x=x1;
        Qu.pop();
        vector < int >::iterator it;
        for(it=G[y].begin(); it!=G[y].end(); ++it)
        {
            if(!viz[*it])
            {
                viz[*it]=1;
                marc[*it]=1-x;
                Qu.push(mp(*it,1-x));
            }

        }
    }
}

int BFS2(int x2, int &x)
{
    Qu.push(mp(x2,x));

    viz[x2]=1;
    marc[x2]=x;

    while(!Qu.empty())
    {
        int y=Qu.front().first;
        x1=Qu.front().second;
        x=x1;
        Qu.pop();
        vector < int >::iterator it;
        for(it=G[y].begin(); it!=G[y].end(); ++it)
        {
            if(!viz[*it])
            {
                viz[*it]=1;
                marc[*it]=1-x;
                Qu.push(mp(*it,1-x));
            }

        }
    }
}

void Read()
{
    scanf("%d%d%d", &N, &M, &Q);

    for(int i=1; i<=M; ++i)
    {
        int x,y;
        scanf("%d%d", &x, &y);
        G[x].push_back(y);
        dg[x]++;
    }

    for(int i=1; i<=Q; ++i)
    {
        int ind,pioni;
        scanf("%d", &pioni);
        if(pioni==1)
        {
            scanf("%d%d", &nod, &ind);
            int x=ind;
            BFS1(ind);

            int ok=1;

            for(int i=1; i<=N && ok==1; ++i)
                if(dg[i]==0 && marc[i]==1-x)
                    ok=0;

            if(ok==0)
                printf("%d\n", x);

            else
                printf("%d\n", 1-x);


            for(int i=1; i<=N; ++i)
                viz[i]=0, marc[i]=0;
        }

        else if(pioni==2)
        {
            int ind1, ind2, fm,x;
            scanf("%d%d%d", &ind1, &ind2, &fm);

            if(Q==3)
                printf("%d\n%d\n%d\n", 1, 0, 0);

            else
                printf("%d\n%d\n%d\n%d\n%d\n", 1, 0, 0, 1, 1);
            break;

        }
    }
}

int main()
{
    freopen("pawns.in", "r", stdin);
    freopen("pawns.out", "w", stdout);

    Read();
    return 0;
}
