#include <cstdio>
#include <cmath>

using namespace std;

double dist(double x1, double y1, double x2, double y2)
{
    return sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
}

double mod(double x)
{
    return x < 0 ? -x : x;
}

int main()
{
    freopen("hogwarts.in", "r", stdin);
    freopen("hogwarts.out", "w", stdout);

    int n,m;
    double v,dharry = 0,ddraco = 0;

    scanf("%d %d %lf", &n, &m, &v);

    double x = 0,y = 0;
    for(int i = 1; i <= n; ++i)
    {
        double x1,y1;
        scanf("%lf %lf\n", &x1, &y1);
        dharry += dist(x,y,x1,y1);
        x = x1;
        y = y1;
    }
    x = 0, y = 0;
    for(int i = 1; i <= n; ++i)
    {
        double x1,y1;
        scanf("%lf %lf\n", &x1, &y1);
        ddraco += dist(x,y,x1,y1);
        x = x1;
        y = y1;
    }

    printf("%lf %lf\n", dharry, ddraco);

    printf("%lf\n", sqrt((mod(dharry*dharry-ddraco*ddraco)))/2);

    return 0;
}
