#include <iostream>
#include <cstdio>
#include <vector>

#define NMAX 10005
#define MMAX 50005

using namespace std;

int N,M,Q;
vector<int> graft[NMAX];
int grad[NMAX];
int par[NMAX][2];
int decizie[NMAX];
int suma;


void citire()
{
    scanf("%d%d%d",&N,&M,&Q);
    for(int i=1; i<=M; i++)
    {
        int x,y;
        scanf("%d%d",&x,&y);
        graft[y].push_back(x);
        grad[x]++;
    }
}



void dfs(int nod,int s)
{
    int ok=1;
    par[nod][s%2]=1;
    if(decizie[nod]==0 && par[nod][1]==1 && par[nod][0]==1)
        decizie[nod]=1;

    for(vector<int>::iterator ii = graft[nod].begin(); ii!=graft[nod].end(); ii++)
    {
        if(decizie[nod])
            decizie[*ii]=decizie[nod]+1;
        dfs(*ii,s+1);
    }

}

void intrebare()
{
    int X,Pi,p,suma=0,ok=0,nr=0,P1;
    scanf("%d",&X);
    for(int j=1; j<=X; j++)
    {
        scanf("%d",&Pi);
        if(par[Pi][1]==1 && par[Pi][0]==0)
        {
            suma+=1;
        }
        else if(decizie[Pi])
        {
            nr++;
        }
        P1 = Pi;
    }
    scanf("%d",&p);

    if(nr==0 && (suma+X-1)%2==1) ///lant
    {
        printf("%d\n",p);
        return;
    }
    else if(nr && X == 1) ///un pion
    {
        if(decizie[Pi]%2==1)
        {
            printf("%d\n",p);
            return;
        }
    }

    printf("%d\n",p^1);
}

void rezolvare()
{
    for(int i=1; i<=N; i++)
        if(grad[i] == 0)
            dfs(i,0);

    for(int i=1; i<=Q; i++)
    {
        intrebare();
    }
}



int main()
{
    freopen("pawns.in","r",stdin);
    freopen("pawns.out","w",stdout);
    citire();
    rezolvare();

    return 0;
}
